BufferedInputFilter (Apache Tomcat 9.0.22 API Documentation)

org.apache.coyote.http11.filters

## Class BufferedInputFilter

- java.lang.Object
- - org.apache.coyote.http11.filters.BufferedInputFilter

- All Implemented Interfaces:
    InputFilter, InputBuffer, ApplicationBufferHandler

      public class BufferedInputFilter
      extends java.lang.Object
      implements InputFilter, ApplicationBufferHandler

  Input filter responsible for reading and buffering the request body, so that it does not interfere with client SSL handshake messages.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BufferedInputFilter()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Amount of bytes still available in a buffer.
    `int` | `doRead(ApplicationBufferHandler handler)` Fills the given ByteBuffer with the buffered request body.
    `long` | `end()` End the current request.
    `void` | `expand(int size)`
    `java.nio.ByteBuffer` | `getByteBuffer()`
    `ByteChunk` | `getEncodingName()` Get the name of the encoding handled by this filter.
    `boolean` | `isFinished()` Has the request body been read fully?
    `void` | `recycle()` Make the filter ready to process the next request.
    `void` | `setBuffer(InputBuffer buffer)` Set the next buffer in the filter pipeline.
    `void` | `setByteBuffer(java.nio.ByteBuffer buffer)`
    `void` | `setLimit(int limit)` Set the buffering limit.
    `void` | `setRequest(Request request)` Reads the request body and buffers it.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BufferedInputFilter

          public BufferedInputFilter()

  - ### Method Detail

    - #### setLimit

          public void setLimit(int limit)

      Set the buffering limit. This should be reset every time the buffer is used.
      Parameters:
        `limit` - The maximum number of bytes that will be buffered

    - #### setRequest

          public void setRequest(Request request)

      Reads the request body and buffers it.
      Specified by:
        `setRequest` in interface `InputFilter`
      Parameters:
        `request` - The request to be associated with this filter

    - #### doRead

          public int doRead(ApplicationBufferHandler handler)
                     throws java.io.IOException

      Fills the given ByteBuffer with the buffered request body.
      Specified by:
        `doRead` in interface `InputBuffer`
      Parameters:
        `handler` - ApplicationBufferHandler that provides the buffer to read data into.
      Returns:
        The number of bytes that have been added to the buffer or -1 for end of stream
      Throws:
        `java.io.IOException` - If an I/O error occurs reading from the input stream

    - #### setBuffer

          public void setBuffer(InputBuffer buffer)

      Description copied from interface: `InputFilter`
      Set the next buffer in the filter pipeline.
      Specified by:
        `setBuffer` in interface `InputFilter`
      Parameters:
        `buffer` - The next buffer

    - #### recycle

          public void recycle()

      Description copied from interface: `InputFilter`
      Make the filter ready to process the next request.
      Specified by:
        `recycle` in interface `InputFilter`

    - #### getEncodingName

          public ByteChunk getEncodingName()

      Description copied from interface: `InputFilter`
      Get the name of the encoding handled by this filter.
      Specified by:
        `getEncodingName` in interface `InputFilter`
      Returns:
        The encoding name as a byte chunk to facilitate comparison with the value read from the HTTP headers which will also be a ByteChunk

    - #### end

          public long end()
                   throws java.io.IOException

      Description copied from interface: `InputFilter`
      End the current request.
      Specified by:
        `end` in interface `InputFilter`
      Returns:
        0 is the expected return value. A positive value indicates that too many bytes were read. This method is allowed to use buffer.doRead to consume extra bytes. The result of this method can't be negative (if an error happens, an IOException should be thrown instead).
      Throws:
        `java.io.IOException` - If an error happens

    - #### available

          public int available()

      Description copied from interface: `InputFilter`
      Amount of bytes still available in a buffer.
      Specified by:
        `available` in interface `InputFilter`
      Returns:
        The number of bytes in the buffer

    - #### isFinished

          public boolean isFinished()

      Description copied from interface: `InputFilter`
      Has the request body been read fully?
      Specified by:
        `isFinished` in interface `InputFilter`
      Returns:
        `true` if the request body has been fully read, otherwise `false`

    - #### setByteBuffer

          public void setByteBuffer(java.nio.ByteBuffer buffer)

      Specified by:
        `setByteBuffer` in interface `ApplicationBufferHandler`

    - #### getByteBuffer

          public java.nio.ByteBuffer getByteBuffer()

      Specified by:
        `getByteBuffer` in interface `ApplicationBufferHandler`

    - #### expand

          public void expand(int size)

      Specified by:
        `expand` in interface `ApplicationBufferHandler`

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.